<?php

class ControllerExtensionModule2invoice extends Controller
{
    const DEFAULT_MODULE_SETTINGS = [
		'name' => '2invoice',
		'status' => 1
    ];
    
    public function index() {
        $this->load->language('extension/module/2invoice');

        $this->document->setTitle($this->language->get('heading_title_settings'));

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/module/2invoice', 'user_token=' . $this->session->data['user_token'], true)
        );
        if (!empty($this->session->data['error_warning'])) {
            $data['error_warning'] = $this->session->data['error_warning'];
            $this->session->data['error_warning'] = null;
        }
        if (!empty($this->session->data['success_result'])) {
            $data['success_result'] = $this->session->data['success_result'];
            $this->session->data['success_result'] = null;
        }

        $log = new Log('2invoice.log');

        if (isset($this->request->post['username'])) {
            $formError = false;
            if (empty($this->request->post['username'])) {
                $data['error_form_username'] = 'Campul "Username" este necesar.';
                $formError = true;
            }
            if (empty($this->request->post['password'])) {
                $data['error_form_password'] = 'Campul "Parola" este necesar.';
                $formError = true;
            }
            if ($formError == false) {
                $log->write('Try login');
                $data = array(
                    'username' => $this->request->post['username'],
                    'password' => $this->request->post['password']
                );
                $ch = curl_init('https://api.2invoice.ro/auth/generate-token');
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
                curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept: application/json', 'Content-Language: ro' ));
                $result = curl_exec($ch);
                if (!curl_errno($ch)) {
                    $info = curl_getinfo($ch);
                    $result = json_decode($result);
                    if ($info['http_code'] == 200) {
                        $log->write('Login success');
                        $data['success_result'] = 'Conectarea s-a realizat cu succes.';
                        $this->db->query("INSERT INTO `2invoice_settings` SET username='" . $this->db->escape($data['username']) . "', password='" . $this->db->escape($data['password']) . "', access_token='" . $this->db->escape($result->access_token) . "', token_expires_at='" . $this->db->escape($result->expires_at->date) . "' ");
                    } elseif ($info['http_code'] == 500) {
                        $data['error_warning'] = 'Eroare la serverele 2invoice.';
                    } else {
                        $data['error_warning'] = $result->message;
                    }
                } else {
                    $data['error_warning'] = 'Curl error: ' . curl_error($ch);
                }
                curl_close($ch);
            }
        }
        if (isset($this->request->post['save_settings']) && !isset($this->request->post['username'])) {
            $settings = $this->db->query("SELECT * FROM `2invoice_settings`");
        
            if ($settings->num_rows) {
                $formError = false;
                if (empty($this->request->post['document_type'])) {
                    $data['error_document_type'] = 'Campul "Tip document" este necesar.';
                    $formError = true;
                }
                if ($formError == false) {
                    $log->write('Try update settings');
                    $settingsData = array();
                    $settingsData['document_type'] = $this->request->post['document_type'];
                    $settingsData['order_number_field_id'] = empty($this->request->post['order_number_field_id']) ? 'null' : $this->request->post['order_number_field_id'];
                    $settingsData['due_date_days'] = $this->request->post['due_date_days']==-1 ? 'null' : $this->request->post['due_date_days'];
                    $settingsData['shipping_field_id'] = empty($this->request->post['shipping_field_id']) ? 'null' : $this->request->post['shipping_field_id'];
                    $settingsData['shipping_method_id'] = empty($this->request->post['shipping_method_id']) ? 'null' : $this->request->post['shipping_method_id'];
                    $settingsData['payment_field_id'] = empty($this->request->post['payment_field_id']) ? 'null' : $this->request->post['payment_field_id'];
                    $settingsData['representant_id'] = empty($this->request->post['representant_id']) ? 'null' : $this->request->post['representant_id'];
                    $settingsData['inventory_id'] = empty($this->request->post['inventory_id']) ? 'null' : $this->request->post['inventory_id'];
                    $settingsData['template_id'] = empty($this->request->post['template_id']) ? 'null' : $this->request->post['template_id'];
                    $settingsData['document_series_id'] = empty($this->request->post['document_series_id']) ? 'null' : $this->request->post['document_series_id'];
                    $settingsData['additional_page_id'] = empty($this->request->post['additional_page_id']) ? 'null' : $this->request->post['additional_page_id'];
                    $settingsData['update_stock'] = $this->request->post['update_stock']=='' ? '0' : $this->request->post['update_stock'];
                    $settingsData['autogenerate'] = $this->request->post['autogenerate']=='' ? '0' : $this->request->post['autogenerate'];
                    $settingsData['fiscal_code_field_id'] = empty($this->request->post['fiscal_code_field_id']) ? 'null' : $this->request->post['fiscal_code_field_id'];
                    $settingsData['ssn_field_id'] = empty($this->request->post['ssn_field_id']) ? 'null' : $this->request->post['ssn_field_id'];
                    $settingsData['trade_register_number_field_id'] = empty($this->request->post['trade_register_number_field_id']) ? 'null' : $this->request->post['trade_register_number_field_id'];
                    $settingsData['company_name_field_id'] = empty($this->request->post['company_name_field_id']) ? 'null' : $this->request->post['company_name_field_id'];
                    $settingsData['bank_name_field_id'] = empty($this->request->post['bank_name_field_id']) ? 'null' : $this->request->post['bank_name_field_id'];
                    $settingsData['bank_number_field_id'] = empty($this->request->post['bank_number_field_id']) ? 'null' : $this->request->post['bank_number_field_id'];
                    $settingsData['client_update_condition'] = empty($this->request->post['client_update_condition']) ? 'null' : $this->request->post['client_update_condition'];
                    $settingsData['document_product_name'] = empty($this->request->post['document_product_name']) ? '#denumire-produs#' : $this->request->post['document_product_name'];
                    $settingsData['shipping_name'] = empty($this->request->post['shipping_name']) ? '' : $this->request->post['shipping_name'];
                    $settingsData['vat_payer'] = $this->request->post['vat_payer']=='' ? '0' : $this->request->post['vat_payer'];
                    $settingsData['product_vat_id'] = empty($this->request->post['product_vat_id']) ? 'null' : $this->request->post['product_vat_id'];
                    $settingsData['transport_vat_id'] = empty($this->request->post['transport_vat_id']) ? 'null' : $this->request->post['transport_vat_id'];
                    $settingsData['code_field'] = $this->request->post['code_field'];

                    $this->db->query("UPDATE `2invoice_settings` SET document_type='" . $this->db->escape($settingsData['document_type']) . "',  document_series_id=" . $settingsData['document_series_id'] . ", due_date_days=" . $settingsData['due_date_days'] . ",  order_number_field_id=" . $settingsData['order_number_field_id'] . ",  shipping_field_id=" . $settingsData['shipping_field_id'] . ", shipping_method_id=" . $settingsData['shipping_method_id'] . ", payment_field_id=".$settingsData['payment_field_id'].", representant_id=".$settingsData['representant_id'].", inventory_id=".$settingsData['inventory_id'].", update_stock=".$settingsData['update_stock'].", autogenerate=".$settingsData['autogenerate'].", template_id=".$settingsData['template_id'].", additional_page_id=".$settingsData['additional_page_id'].", fiscal_code_field_id=".$settingsData['fiscal_code_field_id'].", ssn_field_id=".$settingsData['ssn_field_id'].", trade_register_number_field_id=".$settingsData['trade_register_number_field_id'].", company_name_field_id=".$settingsData['company_name_field_id'].", bank_name_field_id=".$settingsData['bank_name_field_id'].", bank_number_field_id=".$settingsData['bank_number_field_id'].", product_vat_id=".$settingsData['product_vat_id'].", transport_vat_id=".$settingsData['transport_vat_id'].", code_field='".$settingsData['code_field']."', vat_payer=".$settingsData['vat_payer'].", document_product_name='".$settingsData['document_product_name']."', shipping_name='".$settingsData['shipping_name']."' WHERE id=".$settings->row['id']);
                    $data['success_result'] = 'Setările au fost salvate cu succes.';
                    $log->write('Update settings success');
                }
            }
        }

        $settings = $this->db->query("SELECT * FROM `2invoice_settings`");
        
        if ($settings->num_rows) {
            $data['settings'] = $settings->row;
            $data['logout'] = $this->url->link('extension/module/2invoice/settings/logout', 'user_token=' . $this->session->data['user_token'], true);
            
            $data['document_type'] = $settings->row['document_type'];
            $data['shipping_field_id'] = $settings->row['shipping_field_id'];
            $data['shipping_method_id'] = $settings->row['shipping_method_id'];
            $data['representant_id'] = $settings->row['representant_id'];
            $data['payment_field_id'] = $settings->row['payment_field_id'];
            $data['inventory_id'] = $settings->row['inventory_id'];
            $data['update_stock'] = $settings->row['update_stock'];
            $data['autogenerate'] = $settings->row['autogenerate'];
            $data['template_id'] = $settings->row['template_id'];
            $data['document_series_id'] = $settings->row['document_series_id'];
            $data['additional_page_id'] = $settings->row['additional_page_id'];
            $data['fiscal_code_field_id'] = $settings->row['fiscal_code_field_id'];
            $data['trade_register_number_field_id'] = $settings->row['trade_register_number_field_id'];
            $data['ssn_field_id'] = $settings->row['ssn_field_id'];
            $data['company_name_field_id'] = $settings->row['company_name_field_id'];
            $data['bank_name_field_id'] = $settings->row['bank_name_field_id'];
            $data['bank_number_field_id'] = $settings->row['bank_number_field_id'];
            $data['client_update_condition'] = $settings->row['client_update_condition'];
            $data['document_product_name'] = $settings->row['document_product_name'];
            $data['shipping_name'] = $settings->row['shipping_name'];
            $data['vat_payer'] = $settings->row['vat_payer'];
            $data['product_vat_id'] = $settings->row['product_vat_id'];
            $data['transport_vat_id'] = $settings->row['transport_vat_id'];
            $data['order_number_field_id'] = $settings->row['order_number_field_id'];
            $data['due_date_days'] = is_null($settings->row['due_date_days']) ? -1 : $settings->row['due_date_days'];
            $data['code_field'] = $settings->row['code_field'];

            $opencart_fields = $this->db->query("SELECT * FROM `" . DB_PREFIX . "custom_field_description`")->rows;
            $data['opencart_fields'] = [];
            foreach ($opencart_fields as $field) {
                if (!isset($data['opencart_fields'][$field['custom_field_id']])) {
                    $data['opencart_fields'][$field['custom_field_id']] = $field['name'];
                }
            }

            $data['representants'] = array();
            $data['document_series'] = array();
            $data['fields'] = array();
            $data['inventories'] = array();
            $data['templates'] = array();
            $data['vats'] = array();
            $data['client_update_conditions'] = array(
                'fiscal_code_email' => 'CIF/CNP sau email',
                'fiscal_code_phone' => 'CIF/CNP sau telefon',
                'fiscal_code' => 'CIF/CNP',
                'phone' => 'Telefon',
                'email' => 'Email'
            );
            $data['code_fields'] = array(
                'model' => 'Model',
                'sku' => 'SKU',
                'upc' => 'UPC',
                'ean' => 'EAN',
                'jan' => 'JAN',
                'isbn' => 'ISBN',
                'mpn' => 'MPN'
            );

            $data['due_date_days_array'] = array();
            for ($i=0; $i <= 90; $i++) {
                $data['due_date_days_array'][] = [
                    'value' => $i,
                    'name' => $i.' '.($i==1 ? 'zi' : 'zile'),
                ];
            }
            
            $authorization = "Authorization: Bearer ".$settings->row['access_token'];
            // Get representants
            $ch = curl_init('https://api.2invoice.ro/users');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization, 'Accept: application/json', 'Content-Language: ro' ));
            $result = curl_exec($ch);
            if (!curl_errno($ch)) {
                $info = curl_getinfo($ch);
                $result = json_decode($result);
                if ($info['http_code'] == 200) {
                    $data['representants'] = $result->users;
                }
            }
            curl_close($ch);

            // Get inventories
            $ch = curl_init('https://api.2invoice.ro/inventories');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization, 'Accept: application/json', 'Content-Language: ro' ));
            $result = curl_exec($ch);
            if (!curl_errno($ch)) {
                $info = curl_getinfo($ch);
                $result = json_decode($result);
                if ($info['http_code'] == 200) {
                    $data['inventories'] = $result->inventories;
                }
            }
            curl_close($ch);

            // Get document series
            $ch = curl_init('https://api.2invoice.ro/document-series?type=invoice');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization, 'Accept: application/json', 'Content-Language: ro' ));
            $result = curl_exec($ch);
            if (!curl_errno($ch)) {
                $info = curl_getinfo($ch);
                $result = json_decode($result);
                if ($info['http_code'] == 200) {
                    foreach ($result->document_series as $document_series) {
                        $document_series->name = 'Serie facturi: '.$document_series->name;
                        $data['document_series'][] = $document_series;
                    }
                }
            }
            curl_close($ch);

            // Get document series
            $ch = curl_init('https://api.2invoice.ro/document-series?type=proform');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization, 'Accept: application/json', 'Content-Language: ro' ));
            $result = curl_exec($ch);
            if (!curl_errno($ch)) {
                $info = curl_getinfo($ch);
                $result = json_decode($result);
                if ($info['http_code'] == 200) {
                    foreach ($result->document_series as $document_series) {
                        $document_series->name = 'Serie proforme: '.$document_series->name;
                        $data['document_series'][] = $document_series;
                    }
                }
            }
            curl_close($ch);
            

            // Get templates
            $ch = curl_init('https://api.2invoice.ro/templates');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization, 'Accept: application/json', 'Content-Language: ro' ));
            $result = curl_exec($ch);
            if (!curl_errno($ch)) {
                $info = curl_getinfo($ch);
                $result = json_decode($result);
                if ($info['http_code'] == 200) {
                    $data['templates'] = $result->templates;
                }
            }
            curl_close($ch);

            // Get custom fields
            $ch = curl_init('https://api.2invoice.ro/custom-fields');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization, 'Accept: application/json', 'Content-Language: ro' ));
            $result = curl_exec($ch);
            if (!curl_errno($ch)) {
                $info = curl_getinfo($ch);
                $result = json_decode($result);
                if ($info['http_code'] == 200) {
                    $data['fields'] = $result->custom_fields;
                }
            }
            curl_close($ch);

            // Get vats
            $ch = curl_init('https://api.2invoice.ro/vats');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization, 'Accept: application/json', 'Content-Language: ro' ));
            $result = curl_exec($ch);
            if (!curl_errno($ch)) {
                $info = curl_getinfo($ch);
                $result = json_decode($result);
                if ($info['http_code'] == 200) {
                    $data['vats'] = $result->vats;
                    $data['vat_payer'] = $result->vat_payer ? 1 : 0;
                }
            }
            curl_close($ch);
        }

        $data['action'] = $this->url->link('extension/module/2invoice', 'user_token=' . $this->session->data['user_token'], true);

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/module/2invoice', $data));
    }

    public function logout()
    {
        $log = new Log('2invoice.log');
        $log->write('Try logout');
        $settings = $this->db->query("SELECT * FROM `2invoice_settings`");
        if ($settings->num_rows) {
            $ch = curl_init('https://api.2invoice.ro/auth/revoke-token');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            $authorization = "Authorization: Bearer ".$settings->row['access_token'];
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization, 'Accept: application/json', 'Content-Language: ro' ));
            $result = curl_exec($ch);
            if (!curl_errno($ch)) {
                $info = curl_getinfo($ch);
                $result = json_decode($result);
                if ($info['http_code'] == 200) {
                    $log->write('logout success');
                    $this->session->data['success_result'] = 'Utilizatorul '.$settings->row['username'].' a fost dezautentificat cu succes.';
                } elseif ($info['http_code'] == 500) {
                    $this->session->data['error_warning'] = 'Eroare la serverele 2invoice.';
                } else {
                    $this->session->data['error_warning'] = $result->message;
                }
            } else {
                $this->session->data['error_warning'] = 'Curl error: ' . curl_error($ch);
            }
            curl_close($ch);
        }
        $this->db->query("DELETE FROM `2invoice_settings`");

        $this->response->redirect($this->url->link('extension/module/2invoice', 'user_token=' . $this->session->data['user_token'], true));
    }

    public function generate()
    {
        $log = new Log('2invoice.log');
        $orderId = $this->request->get['order_id'];
        $log->write('Try generate document for order_id='.$orderId);
        $this->session->data['app_2invoiceResultOK'] = false;
        $settings = $this->db->query("SELECT * FROM `2invoice_settings`");
        if ($settings->num_rows) {
            $order = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order` WHERE order_id=".$orderId);
            if ($order->num_rows) {
                $authorization = "Authorization: Bearer ".$settings->row['access_token'];
                $order = $order->row;
                $document = array();
                $document['currency'] = $order['currency_code'];
                if ($order['currency_code'] != 'RON') {
                    $document['currency_display'] = 'ron_currency';
                }
                if (!is_null($settings->row['due_date_days'])) {
                    $document['show_due_date'] = 1;
                    $document['due_date'] = date('Y-m-d', strtotime('+'.$settings->row['due_date_days'].' days'));
                }
                $address = $order['payment_address_1'];
                if (!empty($order['payment_address_2'])) {
                    $address .= ', '.$order['payment_address2'];
                }
                $address .= ', '.$order['payment_city'].', '.$order['payment_zone'];
                $country = $this->db->query("SELECT iso_code_2 FROM `" . DB_PREFIX . "country` WHERE country_id=".$order['payment_country_id']);
                if ($country->num_rows) {
                    $country = $country->row['iso_code_2'];
                } else {
                    $country = 'RO';
                }
                $document['client'] = array(
                    'first_name' => $order['payment_firstname'],
                    'last_name' => $order['payment_lastname'],
                    'company_name' => $order['payment_company'],
                    'address' => $address,
                    'postal_code' => $order['payment_postcode'],
                    'country' => $country,
                    'company_type_id' => empty($order['payment_company']) ? 2 : 1,
                    'phone' => $order['telephone'],
                    'email' => $order['email'],
                    'fax' => $order['fax']
                );
                $bankName = '';
                $bankNumber = '';
                if ($order['customer_id']!=0) {
                    $customer = $this->db->query("SELECT * FROM `" . DB_PREFIX . "customer` WHERE customer_id=".$order['customer_id']);
                    if ($customer->num_rows) {
                        $customerCustomFields = json_decode($customer->row['custom_field']);
                        foreach ($customerCustomFields as $key => $customField) {
                            if (!empty($customField)) {
                                if (!empty($settings->row['fiscal_code_field_id']) && $key == $settings->row['fiscal_code_field_id']) {
                                    $document['client']['ssn_fiscal_code'] = $customField;
                                } elseif (!empty($settings->row['ssn_field_id']) && $key == $settings->row['ssn_field_id']) {
                                    $document['client']['ssn_fiscal_code'] = $customField;
                                } elseif (!empty($settings->row['trade_register_number_field_id']) && $key == $settings->row['trade_register_number_field_id']) {
                                    $document['client']['trade_register_number'] = $customField;
                                } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                                    $document['client']['company_name'] = $customField;
                                } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                                    $document['client']['company_name'] = $customField;
                                } elseif (!empty($settings->row['bank_name_field_id']) && $key == $settings->row['bank_name_field_id']) {
                                    $bankName = $customField;
                                } elseif (!empty($settings->row['bank_number_field_id']) && $key == $settings->row['bank_number_field_id']) {
                                    $bankNumber = $customField;
                                }
                            }
                        }
                    }
                }
                $orderCustomFields = json_decode($order['custom_field']);
                foreach ($orderCustomFields as $key => $customField) {
                    if (!empty($customField)) {
                        if (!empty($settings->row['fiscal_code_field_id']) && $key == $settings->row['fiscal_code_field_id']) {
                            $document['client']['ssn_fiscal_code'] = $customField;
                        } elseif (!empty($settings->row['ssn_field_id']) && $key == $settings->row['ssn_field_id']) {
                            $document['client']['ssn_fiscal_code'] = $customField;
                        } elseif (!empty($settings->row['trade_register_number_field_id']) && $key == $settings->row['trade_register_number_field_id']) {
                            $document['client']['trade_register_number'] = $customField;
                        } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                            $document['client']['company_name'] = $customField;
                        } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                            $document['client']['company_name'] = $customField;
                        } elseif (!empty($settings->row['bank_name_field_id']) && $key == $settings->row['bank_name_field_id']) {
                            $bankName = $customField;
                        } elseif (!empty($settings->row['bank_number_field_id']) && $key == $settings->row['bank_number_field_id']) {
                            $bankNumber = $customField;
                        }
                    }
                }
                $paymentCustomFields = json_decode($order['payment_custom_field']);
                foreach ($paymentCustomFields as $key => $customField) {
                    if (!empty($customField)) {
                        if (!empty($settings->row['fiscal_code_field_id']) && $key == $settings->row['fiscal_code_field_id']) {
                            $document['client']['ssn_fiscal_code'] = $customField;
                        } elseif (!empty($settings->row['ssn_field_id']) && $key == $settings->row['ssn_field_id']) {
                            $document['client']['ssn_fiscal_code'] = $customField;
                        } elseif (!empty($settings->row['trade_register_number_field_id']) && $key == $settings->row['trade_register_number_field_id']) {
                            $document['client']['trade_register_number'] = $customField;
                        } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                            $document['client']['company_name'] = $customField;
                        } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                            $document['client']['company_name'] = $customField;
                        } elseif (!empty($settings->row['bank_name_field_id']) && $key == $settings->row['bank_name_field_id']) {
                            $bankName = $customField;
                        } elseif (!empty($settings->row['bank_number_field_id']) && $key == $settings->row['bank_number_field_id']) {
                            $bankNumber = $customField;
                        }
                    }
                }
                $document['client']['bank_details'] = $bankName."\n".$bankNumber;
                if (!empty($document['client']['ssn_fiscal_code']) && strlen($document['client']['ssn_fiscal_code'])<12) {
                    $document['client']['company_type_id'] = 1;
                }
                $document['client']['update_condition'] = $settings->row['client_update_condition'];
                if (!empty($settings->row['representant_id'])) {
                    $document['representant_id'] = $settings->row['representant_id'];
                }
                if (!empty($settings->row['document_series_id'])) {
                    $document['document_series_id'] = $settings->row['document_series_id'];
                }
                if (!empty($settings->row['template_id'])) {
                    $document['template_id'] = $settings->row['template_id'];
                }
                if (!empty($settings->row['additional_page_id'])) {
                    $document['additional_pages'] = [ ['id' => $settings->row['additional_page_id']] ];
                }
                if (!empty($settings->row['inventory_id'])) {
                    $document['inventory_id'] = $settings->row['inventory_id'];
                }
                if (!empty($settings->row['update_stock'])) {
                    $document['update_stock'] = $settings->row['update_stock'];
                }
                $customFields = [];
                if (!empty($settings->row['shipping_field_id'])) {
                    $shippingAddress = $order['shipping_address_1'];
                    if (!empty($order['shipping_address_2'])) {
                        $shippingAddress .= ', '.$order['shipping_address_2'];
                    }
                    $shippingAddress .= ', '.$order['shipping_city'].', '.$order['shipping_zone'].', '.$order['shipping_postcode'];
                    if ($order['shipping_country'] != 'Romania') {
                        $shippingAddress .= ', '.$order['shipping_country'];
                    }
                    array_push($customFields, array(
                        'id' => $settings->row['shipping_field_id'],
                        'value' => $shippingAddress
                    ));
                }
                if (!empty($settings->row['payment_field_id'])) {
                    array_push($customFields, array(
                        'id' => $settings->row['payment_field_id'],
                        'value' => $order['payment_method']
                    ));
                }
                if (!empty($settings->row['shipping_method_id'])) {
                    array_push($customFields, array(
                        'id' => $settings->row['shipping_method_id'],
                        'value' => $order['shipping_method']
                    ));
                }
                if (!empty($settings->row['order_number_field_id'])) {
                    array_push($customFields, array(
                        'id' => $settings->row['order_number_field_id'],
                        'value' => $orderId
                    ));
                }
                if (count($customFields)>0) {
                    $document['custom_fields'] = $customFields;
                }
                $document['products'] = [];
                $products = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order_product` WHERE order_id=".$orderId);
                foreach ($products->rows as $product) {
                    $code = null;
                    if ($settings->row['code_field'] == 'model') {
                        $code = $product['model'];
                    } else {
                        $productDB = $this->db->query("SELECT * FROM `" . DB_PREFIX . "product` WHERE product_id=".$product['product_id']);
                        if ($productDB->rows && isset($productDB->row[$settings->row['code_field']])) {
                            $code = $productDB->row[$settings->row['code_field']];
                        }
                    }
                    $document_product_name = $settings->row['document_product_name'];
                    $document_product_name = str_replace('#denumire-produs#', $product['name'], $document_product_name);
                    $document_product_name = str_replace('#cod-produs#', $code, $document_product_name);
                    array_push($document['products'], array(
                        'name' => $document_product_name,
                        'quantity' => $product['quantity'],
                        'total_price' => $product['total']+($product['tax']*$product['quantity']),
                        'vat_id' => $settings->row['product_vat_id'],
                        'code' => $code,
                    ));
                }
                $orderShipping = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order_total` WHERE order_id=".$orderId.' AND code="shipping"');
                if ($orderShipping->rows && $orderShipping->row['value']!=0) {
                    $shipping_name = $settings->row['shipping_name'];
                    $shipping_name = str_replace('#curier#', $order['shipping_method'], $shipping_name);
                    array_push($document['products'], array(
                        'name' => $shipping_name,
                        'quantity' => 1,
                        'total_price' => $orderShipping->row['value'],
                        'vat_id' => $settings->row['transport_vat_id']
                    ));
                }
                $ch = curl_init('https://api.2invoice.ro/' . $settings->row['document_type'] . 's');
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($document));
                curl_setopt($ch, CURLOPT_HTTPHEADER, array($authorization, 'Accept: application/json', 'Content-Language: ro'));
                $result = curl_exec($ch);
                if (!curl_errno($ch)) {
                    $info = curl_getinfo($ch);
                    $result = json_decode($result);
                    if ($info['http_code'] == 200) {
                        if (isset($result->status) && $result->status == 'OK') {
                            $log->write('Document generated success for order_id='.$orderId);
                            $this->db->query("INSERT INTO `2invoice_orders` SET order_id=".$orderId.", `2invoice_id`=".$result->{$settings->row['document_type'].'_id'}.", document_type='".$settings->row['document_type']."', `token`='".$result->api_key."' ");
                            $this->session->data['app_2invoiceResultOK'] = true;
                            $this->session->data['app_2invoiceResult'] = ($settings->row['document_type']=='invoice' ? 'Factura' : 'Proforma').' a fost generată cu succes.';
                        } else {
                            $this->session->data['app_2invoiceResult'] = 'Eroare: '.print_r($result, true);
                        }
                    } elseif ($info['http_code'] == 401) {
                        // generate a new token and try again
                    } elseif ($info['http_code'] == 422) {
                        $this->session->data['app_2invoiceResult'] = 'Eroare la validarea datelor.<br/>EROARE: '.print_r($result, true).'<br/>DATE: '.print_r($document, true);
                    } elseif ($info['http_code'] == 404) {
                        $this->session->data['app_2invoiceResult'] = 'Eroare resursa nu a fost gasita.';
                    } elseif ($info['http_code'] == 500) {
                        $this->session->data['app_2invoiceResult'] = 'Eroare la serverele 2invoice.';
                    } else {
                        $this->session->data['app_2invoiceResult'] = $result->message;
                    }
                } else {
                    $this->session->data['app_2invoiceResult'] = 'Curl error: ' . curl_error($ch);
                }
                curl_close($ch);
            } else {
                $this->session->data['app_2invoiceResult'] = 'Comanda nu a fost gasita.';
            }
        } else {
            $this->session->data['app_2invoiceResult'] = '2invoice nu este configurat.';
        }
        
        $this->response->redirect($this->url->link('sale/order/info', 'user_token=' . $this->session->data['user_token'] . '&order_id=' . $orderId, true));
    }

    public function install()
    {
        $this->load->model('setting/event');
        $this->model_setting_event->addEvent('new_order_2invoice', 'catalog/model/checkout/order/addOrderHistory/before', 'extension/module/2invoice/new_order');
        
        $this->db->query("DROP TABLE IF EXISTS `2invoice_settings`");
        $this->db->query("CREATE TABLE `2invoice_settings` ( `id` int(10) unsigned NOT NULL AUTO_INCREMENT, `username` varchar(128) NOT NULL, `password` varchar(128) NOT NULL, `access_token` text NOT NULL, `token_expires_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP, `document_type` varchar(10) DEFAULT 'proform', `autogenerate` tinyint(1) DEFAULT '0', `representant_id` int(10) unsigned DEFAULT NULL, `document_series_id` int(10) unsigned DEFAULT NULL, `order_number_field_id` int(10) unsigned DEFAULT NULL, `due_date_days` int(10) unsigned DEFAULT NULL, `shipping_field_id` int(10) unsigned DEFAULT NULL, `shipping_method_id` int(10) unsigned DEFAULT NULL, `payment_field_id` int(10) unsigned DEFAULT NULL, `template_id` int(10) unsigned DEFAULT NULL, `additional_page_id` int(10) unsigned DEFAULT NULL, `inventory_id` int(10) unsigned DEFAULT NULL, `code_field` varchar(10) NOT NULL DEFAULT 'model', `update_stock` tinyint(4) DEFAULT '0', `fiscal_code_field_id` int(11) DEFAULT NULL, `trade_register_number_field_id` int(11) DEFAULT NULL, `ssn_field_id` int(11) DEFAULT NULL, `company_name_field_id` int(11) DEFAULT NULL, `bank_name_field_id` int(11) DEFAULT NULL, `bank_number_field_id` int(11) DEFAULT NULL, `client_update_condition` varchar(20) NOT NULL DEFAULT 'fiscal_code_email', `vat_payer` tinyint(1) NOT NULL DEFAULT '1', `product_vat_id` int(10) unsigned DEFAULT NULL, `transport_vat_id` int(10) unsigned DEFAULT NULL, `document_product_name` varchar(255) NOT NULL DEFAULT '#denumire-produs# - #cod-produs#', `shipping_name` varchar(255) NOT NULL DEFAULT 'Cheltuieli transport #curier#', PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;");

        $this->db->query("CREATE TABLE IF NOT EXISTS `2invoice_orders` (`id` int(11) NOT NULL AUTO_INCREMENT, `order_id` int(10) unsigned DEFAULT NULL, `2invoice_id` int(10) unsigned DEFAULT NULL, `document_type` varchar(10) DEFAULT NULL, `token` varchar(255) DEFAULT NULL, PRIMARY KEY (`id`)) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;");

        $this->load->model('setting/setting');
        $this->model_setting_setting->editSetting('module_2invoice', ['module_2invoice_status'=>1]);

        $log = new Log('2invoice.log');
        $log->write('Installed');
    }

    public function uninstall()
    {
        $this->load->model('setting/event');
        $this->model_setting_event->deleteEvent('new_order_2invoice');

        $this->db->query("DROP TABLE IF EXISTS `2invoice_settings`");
        // $this->db->query("DROP TABLE IF EXISTS `2invoice_orders`");

        $this->load->model('setting/setting');
        $this->model_setting_setting->deleteSetting('module_2invoice');

        $log = new Log('2invoice.log');
        $log->write('Uninstalled');
    }
}
