<?php

class ControllerExtensionModule2invoice extends Controller {

    public function new_order($route, $data)
    {
        $log = new Log('2invoice.log');
        $orderId = $data[0];
        $log->write('Try autogenerate document for order_id='.$orderId);
        $this->session->data['app_2invoiceResultOK'] = false;
        $settings = $this->db->query("SELECT * FROM `2invoice_settings`");
        if ($settings->num_rows && $settings->row['autogenerate'] == 1) {
            $app2invoiceOrder = $this->db->query("SELECT * FROM `2invoice_orders` WHERE `order_id`=" . $orderId);
		    if (count($app2invoiceOrder->rows)==0) {
            $order = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order` WHERE order_id=".$orderId);
                if ($order->num_rows) {
                    $authorization = "Authorization: Bearer ".$settings->row['access_token'];
                    $order = $order->row;
                    $document = array();
                    $document['currency'] = $order['currency_code'];
                    if ($order['currency_code'] != 'RON') {
                        $document['currency_display'] = 'ron_currency';
                    }
                    if (!is_null($settings->row['due_date_days'])) {
                        $document['show_due_date'] = 1;
                        $document['due_date'] = date('Y-m-d', strtotime('+'.$settings->row['due_date_days'].' days'));
                    }
                    $address = $order['payment_address_1'];
                    if (!empty($order['payment_address_2'])) {
                        $address .= ', '.$order['payment_address2'];
                    }
                    $address .= ', '.$order['payment_city'].', '.$order['payment_zone'];
                    $country = $this->db->query("SELECT iso_code_2 FROM `" . DB_PREFIX . "country` WHERE country_id=".$order['payment_country_id']);
                    if ($country->num_rows) {
                        $country = $country->row['iso_code_2'];
                    } else {
                        $country = 'RO';
                    }
                    $document['client'] = array(
                        'first_name' => $order['payment_firstname'],
                        'last_name' => $order['payment_lastname'],
                        'company_name' => $order['payment_company'],
                        'address' => $address,
                        'postal_code' => $order['payment_postcode'],
                        'country' => $country,
                        'company_type_id' => empty($order['payment_company']) ? 2 : 1,
                        'phone' => $order['telephone'],
                        'email' => $order['email'],
                        'fax' => $order['fax']
                    );
                    $bankName = '';
                    $bankNumber = '';
                    if ($order['customer_id']!=0) {
                        $customer = $this->db->query("SELECT * FROM `" . DB_PREFIX . "customer` WHERE customer_id=".$order['customer_id']);
                        if ($customer->num_rows) {
                            $customerCustomFields = json_decode($customer->row['custom_field']);
                            foreach ($customerCustomFields as $key => $customField) {
                                if (!empty($customField)) {
                                    if (!empty($settings->row['fiscal_code_field_id']) && $key == $settings->row['fiscal_code_field_id']) {
                                        $document['client']['ssn_fiscal_code'] = $customField;
                                    } elseif (!empty($settings->row['ssn_field_id']) && $key == $settings->row['ssn_field_id']) {
                                        $document['client']['ssn_fiscal_code'] = $customField;
                                    } elseif (!empty($settings->row['trade_register_number_field_id']) && $key == $settings->row['trade_register_number_field_id']) {
                                        $document['client']['trade_register_number'] = $customField;
                                    } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                                        $document['client']['company_name'] = $customField;
                                    } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                                        $document['client']['company_name'] = $customField;
                                    } elseif (!empty($settings->row['bank_name_field_id']) && $key == $settings->row['bank_name_field_id']) {
                                        $bankName = $customField;
                                    } elseif (!empty($settings->row['bank_number_field_id']) && $key == $settings->row['bank_number_field_id']) {
                                        $bankNumber = $customField;
                                    }
                                }
                            }
                        }
                    }
                    $orderCustomFields = json_decode($order['custom_field']);
                    foreach ($orderCustomFields as $key => $customField) {
                        if (!empty($customField)) {
                            if (!empty($settings->row['fiscal_code_field_id']) && $key == $settings->row['fiscal_code_field_id']) {
                                $document['client']['ssn_fiscal_code'] = $customField;
                            } elseif (!empty($settings->row['ssn_field_id']) && $key == $settings->row['ssn_field_id']) {
                                $document['client']['ssn_fiscal_code'] = $customField;
                            } elseif (!empty($settings->row['trade_register_number_field_id']) && $key == $settings->row['trade_register_number_field_id']) {
                                $document['client']['trade_register_number'] = $customField;
                            } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                                $document['client']['company_name'] = $customField;
                            } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                                $document['client']['company_name'] = $customField;
                            } elseif (!empty($settings->row['bank_name_field_id']) && $key == $settings->row['bank_name_field_id']) {
                                $bankName = $customField;
                            } elseif (!empty($settings->row['bank_number_field_id']) && $key == $settings->row['bank_number_field_id']) {
                                $bankNumber = $customField;
                            }
                        }
                    }
                    $paymentCustomFields = json_decode($order['payment_custom_field']);
                    foreach ($paymentCustomFields as $key => $customField) {
                        if (!empty($customField)) {
                            if (!empty($settings->row['fiscal_code_field_id']) && $key == $settings->row['fiscal_code_field_id']) {
                                $document['client']['ssn_fiscal_code'] = $customField;
                            } elseif (!empty($settings->row['ssn_field_id']) && $key == $settings->row['ssn_field_id']) {
                                $document['client']['ssn_fiscal_code'] = $customField;
                            } elseif (!empty($settings->row['trade_register_number_field_id']) && $key == $settings->row['trade_register_number_field_id']) {
                                $document['client']['trade_register_number'] = $customField;
                            } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                                $document['client']['company_name'] = $customField;
                            } elseif (!empty($settings->row['company_name_field_id']) && $key == $settings->row['company_name_field_id']) {
                                $document['client']['company_name'] = $customField;
                            } elseif (!empty($settings->row['bank_name_field_id']) && $key == $settings->row['bank_name_field_id']) {
                                $bankName = $customField;
                            } elseif (!empty($settings->row['bank_number_field_id']) && $key == $settings->row['bank_number_field_id']) {
                                $bankNumber = $customField;
                            }
                        }
                    }
                    $document['client']['bank_details'] = $bankName."\n".$bankNumber;
                    if (!empty($document['client']['ssn_fiscal_code']) && strlen($document['client']['ssn_fiscal_code'])<12) {
                        $document['client']['company_type_id'] = 1;
                    }
                    $document['client']['update_condition'] = $settings->row['client_update_condition'];
                    if (!empty($settings->row['representant_id'])) {
                        $document['representant_id'] = $settings->row['representant_id'];
                    }
                    if (!empty($settings->row['document_series_id'])) {
                        $document['document_series_id'] = $settings->row['document_series_id'];
                    }
                    if (!empty($settings->row['template_id'])) {
                        $document['template_id'] = $settings->row['template_id'];
                    }
                    if (!empty($settings->row['additional_page_id'])) {
                        $document['additional_pages'] = [ ['id' => $settings->row['additional_page_id']] ];
                    }
                    if (!empty($settings->row['inventory_id'])) {
                        $document['inventory_id'] = $settings->row['inventory_id'];
                    }
                    if (!empty($settings->row['update_stock'])) {
                        $document['update_stock'] = $settings->row['update_stock'];
                    }
                    $customFields = [];
                    if (!empty($settings->row['shipping_field_id'])) {
                        $shippingAddress = $order['shipping_address_1'];
                        if (!empty($order['shipping_address_2'])) {
                            $shippingAddress .= ', '.$order['shipping_address_2'];
                        }
                        $shippingAddress .= ', '.$order['shipping_city'].', '.$order['shipping_zone'].', '.$order['shipping_postcode'];
                        if ($order['shipping_country'] != 'Romania') {
                            $shippingAddress .= ', '.$order['shipping_country'];
                        }
                        array_push($customFields, array(
                            'id' => $settings->row['shipping_field_id'],
                            'value' => $shippingAddress
                        ));
                    }
                    if (!empty($settings->row['payment_field_id'])) {
                        array_push($customFields, array(
                            'id' => $settings->row['payment_field_id'],
                            'value' => $order['payment_method']
                        ));
                    }
                    if (!empty($settings->row['shipping_method_id'])) {
                        array_push($customFields, array(
                            'id' => $settings->row['shipping_method_id'],
                            'value' => $order['shipping_method']
                        ));
                    }
                    if (!empty($settings->row['order_number_field_id'])) {
                        array_push($customFields, array(
                            'id' => $settings->row['order_number_field_id'],
                            'value' => $orderId
                        ));
                    }
                    if (count($customFields)>0) {
                        $document['custom_fields'] = $customFields;
                    }
                    $document['products'] = [];
                    $products = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order_product` WHERE order_id=".$orderId);
                    foreach ($products->rows as $product) {
                        $code = null;
                        if ($settings->row['code_field'] == 'model') {
                            $code = $product['model'];
                        } else {
                            $productDB = $this->db->query("SELECT * FROM `" . DB_PREFIX . "product` WHERE product_id=".$product['product_id']);
                            if ($productDB->rows && isset($productDB->row[$settings->row['code_field']])) {
                                $code = $productDB->row[$settings->row['code_field']];
                            }
                        }
                        $document_product_name = $settings->row['document_product_name'];
                        $document_product_name = str_replace('#denumire-produs#', $product['name'], $document_product_name);
                        $document_product_name = str_replace('#cod-produs#', $code, $document_product_name);
                        array_push($document['products'], array(
                            'name' => $document_product_name,
                            'quantity' => $product['quantity'],
                            'total_price' => $product['total']+($product['tax']*$product['quantity']),
                            'vat_id' => $settings->row['product_vat_id'],
                            'code' => $code,
                        ));
                    }
                    $orderShipping = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order_total` WHERE order_id=".$orderId.' AND code="shipping"');
                    if ($orderShipping->rows && $orderShipping->row['value']!=0) {
                        $shipping_name = $settings->row['shipping_name'];
                        $shipping_name = str_replace('#curier#', $order['shipping_method'], $shipping_name);
                        array_push($document['products'], array(
                            'name' => $shipping_name,
                            'quantity' => 1,
                            'total_price' => $orderShipping->row['value'],
                            'vat_id' => $settings->row['transport_vat_id']
                        ));
                    }
                    $ch = curl_init('https://api.2invoice.ro/' . $settings->row['document_type'] . 's');
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                    curl_setopt($ch, CURLOPT_POST, true);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($document));
                    curl_setopt($ch, CURLOPT_HTTPHEADER, array($authorization, 'Accept: application/json', 'Content-Language: ro'));
                    $result = curl_exec($ch);
                    if (!curl_errno($ch)) {
                        $info = curl_getinfo($ch);
                        $result = json_decode($result);
                        if ($info['http_code'] == 200) {
                            $this->db->query("INSERT INTO `2invoice_orders` SET order_id=".$orderId.", `2invoice_id`=".$result->{$settings->row['document_type'].'_id'}.", document_type='".$settings->row['document_type']."', `token`='".$result->api_key."' ");
                        }
                    }
                    curl_close($ch);
                }
            }
        }
    }
}